#[doc = "Register `AV_PAIRS_32B3` reader"]
pub struct R(crate::R<AV_PAIRS_32B3_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<AV_PAIRS_32B3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<AV_PAIRS_32B3_SPEC>> for R {
    fn from(reader: crate::R<AV_PAIRS_32B3_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `AV_PAIRS_32B3` writer"]
pub struct W(crate::W<AV_PAIRS_32B3_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<AV_PAIRS_32B3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<AV_PAIRS_32B3_SPEC>> for W {
    fn from(writer: crate::W<AV_PAIRS_32B3_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `DATA32` reader - Address or Value Word"]
pub struct DATA32_R(crate::FieldReader<u32, u32>);
impl DATA32_R {
    pub(crate) fn new(bits: u32) -> Self {
        DATA32_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for DATA32_R {
    type Target = crate::FieldReader<u32, u32>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `DATA32` writer - Address or Value Word"]
pub struct DATA32_W<'a> {
    w: &'a mut W,
}
impl<'a> DATA32_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff_ffff) | (value as u32 & 0xffff_ffff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:31 - Address or Value Word"]
    #[inline(always)]
    pub fn data32(&self) -> DATA32_R {
        DATA32_R::new((self.bits & 0xffff_ffff) as u32)
    }
}
impl W {
    #[doc = "Bits 0:31 - Address or Value Word"]
    #[inline(always)]
    pub fn data32(&mut self) -> DATA32_W {
        DATA32_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "32b Addr/Value pair Section\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [av_pairs_32b3](index.html) module"]
pub struct AV_PAIRS_32B3_SPEC;
impl crate::RegisterSpec for AV_PAIRS_32B3_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [av_pairs_32b3::R](R) reader structure"]
impl crate::Readable for AV_PAIRS_32B3_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [av_pairs_32b3::W](W) writer structure"]
impl crate::Writable for AV_PAIRS_32B3_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets AV_PAIRS_32B3 to value 0"]
impl crate::Resettable for AV_PAIRS_32B3_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
